%define aurox_ver 10.0
%define rel 1

%define _without_java 1

# $Id: kdebindings.spec,v 1.22 2004/03/03 18:37:22 rexdieter Exp $

%define kdelibs_ver 6:%{version}
%define kdebase_ver 6:%{version}

### stil need fix to build java -> disable java at the moment
#define support_arch none
%define support_arch %{ix86} alpha ia64 ppc

%define mozilla_ver 37:1.6
%define qt_version 1:3.3.2

## JAVA
# Conditional build:
# --without java
# --with java=/specify/path/to/java/bin
# Defaults if no --without java or --with java specified
%define java_default java-1.4.2
%if "%{?_without_java}" != "%{nil}"
%define java %{?_without_java}
%else
%{!?_with_java:%define java --with-java=/usr/lib/jvm/%{java_default}}
%{!?_with_java:BuildRequires: %{java_default}-devel }
# User-specified java
%{?_with_java:%define java --with-java=%(echo %{_with_java} | sed -e s/.*=// )}
%endif

# FIXME
%define perl 0 
%define python 1 

%define is_release 2 
%define monolithic 1 

Name:	 kdebindings
Summary: KDE bindings to non-C++ languages
Epoch:	 0
Version: 3.2.3
Release: %{aurox_ver}.aur.%{rel}
Source:  ftp://ftp.kde.org/pub/kde/stable/3.2.3/src/kdebindings-3.2.3.tar.bz2
URL:	 http://www.kde.org/
License: GPL
Group:	 User Interface/Desktops
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

Patch0: kde-libtool.patch
Patch3: kdebindings-3.1-lib64ize.patch
Patch4: kdebindings-3.1-ssl-krb5.patch
Patch6: kdebindings-3.2.0-python2.patch

Requires: kdelibs >= %{kdelibs_ver}
Requires: kdebase >= %{kdebase_ver}

%if "%{is_release}" != "1"
BuildRequires: autoconf >= 2.53
BuildRequires: automake >= 1.6
%endif
BuildRequires: libtool
BuildRequires: kdelibs-devel >= %{kdelibs_ver}
BuildRequires: mozilla-devel >= %{mozilla_ver}

## gcc version in use? 
BuildRequires: gcc-c++
%define gcc_ver %(rpm -q --qf '%%{version}' gcc-c++ )
%if "%{gcc_ver}" == "2.96"
%define kdec 0
%endif


Prereq: /sbin/ldconfig

%if "%{?monolithic}" == "1"
Obsoletes: %{name}-kdec < %{epoch}:%{version}-%{release}
Obsoletes: %{name}-kmozilla < %{epoch}:%{version}-%{release}
Obsoletes: %{name}-qtc < %{epoch}:%{version}-%{release}
Obsoletes: %{name}-kdejava < %{epoch}:%{version}-%{release}
Obsoletes: %{name}-qtjava < %{epoch}:%{version}-%{release}

%if "%{?kdec}" != "0"
Provides: %{name}-kdec = %{epoch}:%{version}-%{release}
%endif
Provides: %{name}-kmozilla = %{epoch}:%{version}-%{release}
Provides: %{name}-qtc = %{epoch}:%{version}-%{release}
%if "%{?_with_java:1}" == "1"
Provides: %{name}-kdejava %{epoch}:%{version}-%{release}
Provides: %{name}-qtjava %{epoch}:%{version}-%{release}
%endif
%endif

%description
KDE/DCOP bindings to non-C++ languages

%package devel
Summary: Development files for %{name}
Group: Development/Libraries
Requires: %{name} = %{epoch}:%{version}-%{release}
Requires: kdelibs-devel >= %{kdelibs_ver} 
%description devel
Development files for the KDE bindings.

Install %{name}-devel if you want to develop non-KDE
applications that talk to KDE.

%ifarch %{mozilla_archs}
%package kmozilla
Summary: KDE bindings to mozilla
Group: User Interface/Desktops
Requires: mozilla
Requires: kdebase >= %{kdebase_ver}
%description kmozilla
KDE bindings to mozilla - embed Mozilla in Konqueror
%endif

%package perl
Summary: Perl bindings to DCOP
Group: Development/Libraries
Requires: kdelibs >= %{kdelibs_ver} 
Requires: perl >= 5.6.0
%description perl
Perl bindings to the DCOP interprocess communication protocol used by KDE

%package python
Summary: Python bindings to DCOP
Group: Development/Libraries
Requires: kdelibs >= %{kdelibs_ver} 
Requires: python2
BuildRequires: python2-devel
%description python
Python bindings to the DCOP interprocess communication protocol used by KDE

%if "%{?_with_java:1}" == "1"
%package qtjava
Summary: Java bindings to Qt
Group: System Environment/Libraries
Requires: qt >= %{qt_version}
Requires: libgcj >= 3.1
Requires: jdkgcj >= 0.2.2
BuildRequires: gcc-java >= 3.1
BuildRequires: libgcj >= 3.1
BuildRequires: jdkgcj >= 0.2.2
%description qtjava
Java bindings to Qt.
%endif

%package qtc
Summary: C bindings to Qt
Group: System Environment/Libraries
Requires: qt >= %{qt_version}
%description qtc
C bindings to Qt.
Install kdebindings-qtc if you wish to develop Qt applications
in C (rather than C++).

%package kdec
Summary: C bindings to KDE
Group: System Environment/Libraries
Requires: qt >= %{qt_version}
Requires: %{name}-qtc >= %{epoch}:%{version}-%{release} 
%description kdec
C bindings to KDE.
Install kdebindings-kdec if you wish to develop Qt applications
in C (rather than C++).

%if "%{?_with_java:1}" == "1"
%package kdejava
Summary: Java bindings to KDE
Group: Development/Libraries
Requires: kdelibs >= %{kdelibs_ver} 
Requires: kdebindings-qtjava = %{epoch}:%{version}-%{release}
Requires: libgcj
%description kdejava
Java bindings to KDE
%endif


%prep
%setup -q

#%patch0 -p1 -b .libtool
#%patch3 -p1 -b .lib64ize
%patch4 -p1 -b .ssl-krb5
%patch6 -p1 -b .python2

%if "%{is_release}" != "1"
  make -f admin/Makefile.common cvs
%endif


%build
unset QTDIR || : ; . /etc/profile.d/qt.sh
unset JAVA_HOME
FLAGS="$RPM_OPT_FLAGS -D_GNU_SOURCE"
# workaround for ia64, need to be fixed later
%ifarch ia64
export CFLAGS="$FLAGS -O0"
export CXXFLAGS="$FLAGS -O0"
%endif
export CFLAGS="$FLAGS"
export CXXFLAGS="$FLAGS"

export DO_NOT_COMPILE=""
%if "%{?kdec}" == "0"
export DO_NOT_COMPILE="$DO_NOT_COMPILE kdec"
%endif
%if "%{?perl}" == "0"
export DO_NOT_COMPILE="$DO_NOT_COMPILE dcopperl"
%endif


#%ifarch %{support_arch}
%if 0
export CFLAGS="$CFLAGS `mozilla-config --cflags`"
export CXXFLAGS="$CXXFLAGS `mozilla-config --cflags`"
export CPPFLAGS="$CPPFLAGS `mozilla-config --cflags`"
export LDFLAGS="$LDFLAGS `mozilla-config --libs`"
%endif

%configure \
  --includedir=%{_includedir}/kde \
  --disable-rpath \
  %{?debug:  --enable-debug --enable-warnings } \
  %{!?debug: --disable-dependency-tracking --disable-debug --disable-warnings } \
  %{?java} \
  --disable-final

## --enable-final BROKEN

make %{?_smp_mflags}

%if %{perl}
pushd dcopperl
perl Makefile.PL <<EOF
$QTDIR/include
$QTDIR/lib
%{_includedir}/kde
%{_libdir}
EOF
make
popd
%endif


%install
rm -rf $RPM_BUILD_ROOT

make install%{!?debug_package:-strip} DESTDIR=$RPM_BUILD_ROOT

%if %{perl}
make -C dcopperl install PREFIX="$RPM_BUILD_ROOT%{_prefix}"
%endif

# misplaced doc files
rm -rf $RPM_BUILD_ROOT/usr/doc


%clean
rm -rf $RPM_BUILD_ROOT


%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig


%files
%defattr(-,root,root)
%{_bindir}/*
%{_libdir}/*.so.*
%{_libdir}/*.la
%{_libdir}/kde3/*
%{_datadir}/applications/kde/*.desktop
%{_datadir}/mimelnk/*/*.desktop
%{_datadir}/services/*
%{_datadir}/servicetypes/*.desktop
%if %{python}
%{_libdir}/python*/*/*
%{_libdir}/python*/*.py
%endif

%if "%{java}" != "%{?_without_java}"
%{_libdir}/java
#%doc %{_docdir}/javalib
%endif

%if %{perl}
%{_libdir}/perl5/site_perl/*/*/auto/DCOP/*
%{_libdir}/perl5/site_perl/*/*/DCOP.pm
%{_libdir}/perl5/site_perl/*/*/DCOP/Object.pm
%{_mandir}/man3/DCOP.3pm*
%endif

%files devel
%defattr(-,root,root)
%{_includedir}/kde/*
#%{_includedir}/dcopc


%changelog
* Tue Jul 27 2004 Aurox Team <aurox@aurox.org> 0:3.2.3-10.0.aur.1
- 3.2.3, small changes in spec
- patch0 and patch1 are out
- without java
- patch for python2 updated
- 3.2.1, Aurox 9.4

* Wed Mar 09 2004 Rex Dieter <rexdieter at sf.net> 0:3.2.1-0.fdr.1
- unpackaged files

* Mon Mar 01 2004 Rex Dieter <rexdieter at sf.net> 0:3.2.1-0.fdr.0
- 3.2.1

* Wed Feb 11 2004 Rex Dieter <rexdieter at sf.net> 0:3.2.0-0.fdr.1
- try java

* Tue Jan 27 2004 Rex Dieter <rexdieter at sf.net> 0:3.2.0-0.fdr.0
- 3.2.0

* Mon Jan 19 2004 Rex Dieter <rexdieter af sf.net> 0:3.1.95-0.fdr.0
- 3.1.95

* Fri Dec 05 2003 Rex Dieter <rexdieter at sf.net> 0:3.1.4-0.fdr.1
- (re)build on/for qt-3.2.x

* Sat Sep 13 2003 Rex Dieter <rexdieter at sf.net> 0:3.1.4-0.fdr.0
- 3.1.4

* Tue Jul 11 2003 Rex Dieter <rexdieter at sf.net> 0:3.1.3-0.fdr.0
- 3.1.3

* Mon May 19 2003 Than Ngo <than@redhat.com> 3.1.2-2
- 3.1.2

* Fri May  2 2003 Than Ngo <than@redhat.com> 3.1.1-3
- remove unneeded patch file

* Wed Apr 30 2003 Elliot Lee <sopwith@redhat.com> 3.1.1-2
- headusage patch for ppc64

* Wed Mar 19 2003 Than Ngo <than@redhat.com> 3.1.1-1
- 3.1.1

* Fri Feb 21 2003 Than Ngo <than@redhat.com> 3.1-4
- get rid of gcc path from dependency_libs

* Wed Feb 19 2003 Elliot Lee <sopwith@redhat.com> 3.1-3
- Fix mozilla building/notbuilding to consistently use mozilla_archs macro
- Remove -O0 cflags from November

* Thu Jan 30 2003 Than Ngo <than@redhat.com> 3.1-2
- lib64'ize
- add fix to build kmozilla binding
- add correct python version

* Tue Jan 28 2003 Than Ngo <than@redhat.com> 3.1-1
- 3.1 release
- cleanup specfile

* Thu Jan 23 2003 Tim Powers <timp@redhat.com> 3.1-0.6
- rebuild

* Mon Jan 13 2003 Thomas Woerner <twoerner@redhat.com> 3.1-0.4
- rc6
- ssl uses krb5

* Tue Dec  3 2002 Tim Powers <timp@redhat.com> 3.1-0.3
- lib64'ize

* Sat Nov 30 2002 Than Ngo <than@redhat.com> 3.1-0.2
- build with -O0 on ia64 x86_64 temporary
- get rid of sub packages

* Thu Nov 28 2002 Than Ngo <than@redhat.com> 3.1-0.1
- update to 3.1 rc4

* Sun Nov 10 2002 Than Ngo <than@redhat.com> 3.0.5-1
- update to 3.0.5

* Thu Nov  7 2002 Than Ngo <than@redhat.com> 3.0.4-2
- cleaned up specfile

* Tue Oct 15 2002 Than Ngo <than@redhat.com> 3.0.4-1
- 3.0.4

* Thu Sep 19 2002 Than Ngo <than@redhat.com> 3.0.3-1.1
- Added missing requires kdelibs-devel in kdebindings-devel (bug #73992)
- Fixed typo bug (bug #51669)
- Added Buildprereq arts-devel instead kdelibs-sound
- Fixed to build on s390/s390x/x86_64

* Mon Aug 12 2002 Than Ngo <than@redhat.com> 3.0.3-1
- 3.0.3
- build using gcc-3.2-0.3

* Mon Jul 22 2002 Tim Powers <timp@redhat.com> 3.0.2-3
- rebuild using gcc-3.2-0.1

* Fri Jul 12 2002 Than Ngo <than@redhat.com> 3.0.2-2
- 3.0.2

* Fri Jun 14 2002 Bernhard Rosenkraenzer <bero@redhat.com> 3.0.2-0.cvs20020614
- Update to current stable branch to make it work with Qt 3.0.4
- Enable building Java bindings (with jdkgcj)

* Thu May 23 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Wed Mar 27 2002 Bernhard Rosenkraenzer <bero@redhat.com> 3.0.0-1
- 3.0.0 final
- Disable building C, Java and Objective-C bindings for now, they require
  a real C++ compiler rather than a something-between-C-and-C++-compiler

* Mon Feb 18 2002 Bernhard Rosenkraenzer <bero@redhat.com> 3.0.0-0.cvs20020218.1
- Update
- Another try at getting the Qt Java bindings to build and actually work with
  gcj.

* Thu Jan 31 2002 Tim Powers <timp@redhat.com>
- rebuilt to solve deps on kdelibs
- don't build kmozilla package for ia64

* Wed Jan 30 2002 Bernhard Rosenkraenzer <bero@redhat.com> 3.0.0-0.cvs20020130.1
- Update
- Get the qt java bindings to build with gcj
- Temporarily disable building KDE-C, KDE-Java, DCOP-perl and DCOP-python
  bindings; they don't compile.

* Mon Jul 23 2001 Bernhard Rosenkraenzer <bero@redhat.com> 2.2-0.cvs20010723.2
- Move python bindings to separate package
- Add perl bindings
- Shut up rpmlint

* Wed Feb 21 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- 2.1

* Sun Jan 28 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- initial RPM
